﻿using System;
using System.Collections.Generic;
using System.Linq;


class Program
{
    static void Main(string[] args)
    {
        Console.WriteLine("// -- Алгоритм Дейкстры -- \\\n");

        Console.WriteLine("Способы ввода графа:");
        Console.WriteLine("[1] - ввести граф вручную.");
        Console.WriteLine("[2] - использовать готовый граф из инструкции к заданию.");
        Console.WriteLine("[3] - использовать готовый граф задача №1 из тетради.\n");


        Console.Write("Введите номер выбранного способа: ");
        int choise = int.Parse(Console.ReadLine());

        Graph graph;
        switch (choise)
        {

            case 1:
                graph = GraphIO.InputGraphFromConsole();
                break;
            case 2:
                graph = GraphIO.InputGraphFromManual();
                break;
            case 3:
                graph = GraphIO.InputGraphFromTetradka();
                break;
            default:
                Console.WriteLine("Выбранного способа не существует. Перезапустите программу.\n");
                return;
        } 

        Console.Write("\nВведите номер изначальной вершины: ");
        int startingVertexNumber = Convert.ToInt32(Console.ReadLine());

        // Найти минимальные расстояния 
        var result = DijkstraMethod.ApplyMethod(graph, startingVertexNumber);

        // Напечатать полученное решение
        DijkstraMethod.PrintSolution(graph, startingVertexNumber, result);
    }
}
