﻿using System;
using System.Collections.Generic;
using System.Linq;


// Класс для вершины графа
public class Vertex
{
    // Номер вершины
    public int Number { get; set; }
    public bool WasVisited { get; private set; }

    // Список сторон для этой вершины
    public List<Edge> Edges { get; set; }

    // Конструктор для вершины
    public Vertex(int number)
    {
        Number = number;
        Edges = new List<Edge>();
    }

    // Добавить сторону к этой вершине
    public void AddEdge(Edge edge)
    {
        Edges.Add(edge);
    }

    public void Visit()
    {
        WasVisited = true;
    }
}